From e613702ab7b9c5de21a5e8b93ea119b800117de3 Mon Sep 17 00:00:00 2001
From: Ludwig Krispenz <lkrispen@redhat.com>
Date: Thu, 8 Feb 2018 14:46:23 +0100
Subject: [PATCH 1/3] move-cldb-to-main-db-part-1

---
 ldap/servers/plugins/replication/cl5_api.c         | 2390 ++++----------------
 ldap/servers/plugins/replication/cl5_api.h         |   49 +-
 ldap/servers/plugins/replication/cl5_config.c      |  146 +-
 ldap/servers/plugins/replication/cl5_init.c        |    2 +-
 ldap/servers/plugins/replication/cl5_test.c        |    4 +-
 ldap/servers/plugins/replication/repl5.h           |    6 +-
 ldap/servers/plugins/replication/repl5_plugins.c   |   23 +-
 ldap/servers/plugins/replication/repl5_replica.c   |   47 +-
 .../plugins/replication/repl5_replica_config.c     |   40 +-
 ldap/servers/slapd/back-ldbm/back-ldbm.h           |    3 +-
 ldap/servers/slapd/back-ldbm/dblayer.c             |  227 +-
 ldap/servers/slapd/back-ldbm/proto-back-ldbm.h     |    1 +
 ldap/servers/slapd/slapi-plugin.h                  |    4 +
 ldap/servers/slapd/tools/dbscan.c                  |    3 +
 14 files changed, 623 insertions(+), 2322 deletions(-)

diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index 89ae995..7320316 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -67,16 +67,6 @@
 
 #define HASH_BACKETS_COUNT 16 /* number of buckets in a hash table */
 
-#define DEFAULT_DB_ENV_OP_FLAGS DB_AUTO_COMMIT
-#define DB_OPEN(oflags, db, txnid, file, database, type, flags, mode, rval)                                   \
-    {                                                                                                         \
-        if (((oflags)&DB_INIT_TXN) && ((oflags)&DB_INIT_LOG)) {                                               \
-            (rval) = (db)->open((db), (txnid), (file), (database), (type), (flags) | DB_AUTO_COMMIT, (mode)); \
-        } else {                                                                                              \
-            (rval) = (db)->open((db), (txnid), (file), (database), (type), (flags), (mode));                  \
-        }                                                                                                     \
-    }
-
 #define TXN_BEGIN(env, parent_txn, tid, flags) \
     (env)->txn_begin((env), (parent_txn), (tid), (flags))
 #define TXN_COMMIT(txn) (txn)->commit((txn), 0)
@@ -134,11 +124,26 @@ typedef struct cl5dbfile
     RUV *maxRUV;    /* ruv that marks the upper boundary of the data */
 } CL5DBFile;
 
+struct cl5DBFileHandle
+/* info about the changelog file in the main database environment */
+/* usage as CL5DBFile, but for new implementation use a new struct
+ * can be replaced later
+ */ 
+{
+	DB *db;		/* db handle to the changelog file*/
+	char *ident;    /* identifier for changelog, used in error messages */
+	int entryCount;	/* number of entries in the file  */
+	int flags;	/* currently used to mark the file as deleted 
+			 * or as initialized */
+	RUV *purgeRUV;  /* ruv to which the file has been purged */
+	RUV *maxRUV;    /* ruv that marks the upper boundary of the data */
+};
+
 /* structure that allows to iterate through entries to be sent to a consumer
    that originated on a particular supplier. */
 struct cl5replayiterator
 {
-    Object *fileObj;
+    cldb_Handle	*fileObj;
     CLC_Buffer *clcache;    /* changelog cache */
     ReplicaId consumerRID;  /* consumer's RID */
     const RUV *consumerRuv; /* consumer's update vector                    */
@@ -148,7 +153,7 @@ struct cl5replayiterator
 typedef struct cl5iterator
 {
     DBC *cursor;  /* current position in the db file    */
-    Object *file; /* handle to release db file object    */
+    cldb_Handle *file; /* handle to release db file object    */
 } CL5Iterator;
 
 /* changelog trimming configuration */
@@ -164,11 +169,9 @@ typedef struct cl5trim
 /* this structure defines 5.0 changelog internals */
 typedef struct cl5desc
 {
-    char *dbDir;            /* absolute path to changelog directory                */
+    char *dbDir;            /* no longer needed, leave here for upgrade functions */
     DB_ENV *dbEnv;          /* db environment shared by all db files            */
     int dbEnvOpenFlags;     /* openflag used for env->open */
-    Objset *dbFiles;        /* ref counted set of changelog files (CL5DBFile)    */
-    PRLock *fileLock;       /* ensures that changelog file is not added twice    */
     CL5OpenMode dbOpenMode; /* how we open db                                    */
     CL5DBConfig dbConfig;   /* database configuration params                    */
     CL5Trim dbTrim;         /* trimming parameters                                */
@@ -193,16 +196,12 @@ static CL5Desc s_cl5Desc = {0};
 /***** Forward Declarations *****/
 
 /* changelog initialization and cleanup */
-static int _cl5Open(const char *dir, const CL5DBConfig *config, CL5OpenMode openMode);
+static int _cl5Open(const CL5DBConfig *config, CL5OpenMode openMode);
 static int _cl5AppInit(void);
 static int _cl5DBOpen(void);
 static void _cl5SetDefaultDBConfig(void);
 static void _cl5SetDBConfig(const CL5DBConfig *config);
-static int _cl5CheckDBVersion(void);
-static int _cl5ReadDBVersion(const char *dir, char *clVersion, int buflen);
-static int _cl5WriteDBVersion(void);
 static void _cl5Close(void);
-static int _cl5Delete(const char *dir, PRBool rmDir);
 static void _cl5DBClose(void);
 
 /* thread management */
@@ -211,31 +210,17 @@ static int _cl5AddThread(void);
 static void _cl5RemoveThread(void);
 
 /* functions that work with individual changelog files */
-static int _cl5NewDBFile(const char *replName, const char *replGen, CL5DBFile **dbFile);
-static int _cl5DBOpenFile(Object *replica, Object **obj, PRBool checkDups);
-static int _cl5DBOpenFileByReplicaName(const char *replName, const char *replGen, Object **obj, PRBool checkDups);
-static void _cl5DBCloseFile(void **data);
-static void _cl5DBDeleteFile(Object *obj);
-static void _cl5DBFileInitialized(Object *obj);
-static int _cl5GetDBFile(Object *replica, Object **obj);
-static int _cl5GetDBFileByReplicaName(const char *replName, const char *replGen, Object **obj);
-static int _cl5AddDBFile(CL5DBFile *file, Object **obj);
-static int _cl5CompareDBFile(Object *el1, const void *el2);
-static char *_cl5Replica2FileName(Object *replica);
-static char *_cl5MakeFileName(const char *replName, const char *replGen);
-static PRBool _cl5FileName2Replica(const char *fileName, Object **replica);
-static int _cl5ExportFile(PRFileDesc *prFile, Object *obj);
-static PRBool _cl5ReplicaInList(Object *replica, Object **replicas);
+static int _cl5ExportFile(PRFileDesc *prFile, cldb_Handle *cldb);
 
 /* data storage and retrieval */
 static int _cl5Entry2DBData(const CL5Entry *entry, char **data, PRUint32 *len);
-static int _cl5WriteOperation(const char *replName, const char *replGen, const slapi_operation_parameters *op, PRBool local);
-static int _cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_operation_parameters *op, PRBool local, void *txn);
-static int _cl5GetFirstEntry(Object *obj, CL5Entry *entry, void **iterator, DB_TXN *txnid);
+static int _cl5WriteOperation(cldb_Handle *cldb, const slapi_operation_parameters *op, PRBool local);
+static int _cl5WriteOperationTxn(cldb_Handle *cldb, const slapi_operation_parameters *op, PRBool local, void *txn);
+static int _cl5GetFirstEntry(cldb_Handle *cldb, CL5Entry *entry, void **iterator, DB_TXN *txnid);
 static int _cl5GetNextEntry(CL5Entry *entry, void *iterator);
 static int _cl5CurrentDeleteEntry(void *iterator);
 static PRBool _cl5IsValidIterator(const CL5Iterator *iterator);
-static int _cl5GetOperation(Object *replica, slapi_operation_parameters *op);
+static int _cl5GetOperation(cldb_Handle *cldb, slapi_operation_parameters *op);
 static const char *_cl5OperationType2Str(int type);
 static int _cl5Str2OperationType(const char *str);
 static void _cl5WriteString(const char *str, char **buff);
@@ -247,18 +232,18 @@ static int _cl5ReadMod(Slapi_Mod *mod, char **buff);
 static int _cl5GetModsSize(LDAPMod **mods);
 static int _cl5GetModSize(LDAPMod *mod);
 static void _cl5ReadBerval(struct berval *bv, char **buff);
-static void _cl5WriteBerval(struct berval *bv, char **buff);
 static int _cl5ReadBervals(struct berval ***bv, char **buff, unsigned int size);
+static void _cl5WriteBerval(struct berval *bv, char **buff);
 static int _cl5WriteBervals(struct berval **bv, char **buff, u_int32_t *size);
-static int32_t _cl5CheckMaxRUV(CL5DBFile *file, RUV *maxruv);
+static int32_t _cl5CheckMaxRUV(cldb_Handle *cldb, RUV *maxruv);
 static int32_t _cl5CheckCSNinCL(const ruv_enum_data *element, void *arg);
 
 /* replay iteration */
 #ifdef FOR_DEBUGGING
 static PRBool _cl5ValidReplayIterator(const CL5ReplayIterator *iterator);
 #endif
-static int _cl5PositionCursorForReplay(ReplicaId consumerRID, const RUV *consumerRuv, Object *replica, Object *fileObject, CL5ReplayIterator **iterator, int *continue_on_missing);
-static int _cl5CheckMissingCSN(const CSN *minCsn, const RUV *supplierRUV, CL5DBFile *file);
+static int _cl5PositionCursorForReplay(ReplicaId consumerRID, const RUV *consumerRuv, Object *replica, CL5ReplayIterator **iterator, int *continue_on_missing);
+static int _cl5CheckMissingCSN(const CSN *minCsn, const RUV *supplierRUV, cldb_Handle *cldb);
 
 /* changelog trimming */
 static int _cl5TrimInit(void);
@@ -266,16 +251,17 @@ static void _cl5TrimCleanup(void);
 static int _cl5TrimMain(void *param);
 static void _cl5DoTrimming(void);
 static void _cl5CompactDBs(void);
-static void _cl5PurgeRID(Object *obj, ReplicaId cleaned_rid);
-static int _cl5PurgeGetFirstEntry(Object *obj, CL5Entry *entry, void **iterator, DB_TXN *txnid, int rid, DBT *key);
+static int _cl5CompactOneDB(Replica *r, void *arg);
+static void _cl5PurgeRID(cldb_Handle *cldb,  ReplicaId cleaned_rid);
+static int _cl5PurgeGetFirstEntry(cldb_Handle *cldb, CL5Entry *entry, void **iterator, DB_TXN *txnid, int rid, DBT *key);
 static int _cl5PurgeGetNextEntry(CL5Entry *entry, void *iterator, DBT *key);
-static void _cl5TrimFile(Object *obj, long *numToTrim);
-static PRBool _cl5CanTrim(time_t time, long *numToTrim);
-static int _cl5ReadRUV(const char *replGen, Object *obj, PRBool purge);
-static int _cl5WriteRUV(CL5DBFile *file, PRBool purge);
-static int _cl5ConstructRUV(const char *replGen, Object *obj, PRBool purge);
-static int _cl5UpdateRUV(Object *obj, CSN *csn, PRBool newReplica, PRBool purge);
-static int _cl5GetRUV2Purge2(Object *fileObj, RUV **ruv);
+static void _cl5TrimFile(Replica *r, long *numToTrim);
+static PRBool _cl5CanTrim(time_t time, long *numToTrim, Replica *replica);
+static int _cl5ReadRUV(cldb_Handle *cldb, PRBool purge);
+static int _cl5WriteRUV(cldb_Handle *cldb, PRBool purge);
+static int _cl5ConstructRUV(cldb_Handle *cldb, PRBool purge);
+static int _cl5UpdateRUV (cldb_Handle *cldb, CSN *csn, PRBool newReplica, PRBool purge);
+static int _cl5GetRUV2Purge2(Replica *r, RUV **ruv);
 void trigger_cl_purging_thread(void *rid);
 
 /* bakup/recovery, import/export */
@@ -283,20 +269,19 @@ static int _cl5LDIF2Operation(char *ldifEntry, slapi_operation_parameters *op, c
 static int _cl5Operation2LDIF(const slapi_operation_parameters *op, const char *replGen, char **ldifEntry, PRInt32 *lenLDIF);
 
 /* entry count */
-static int _cl5GetEntryCount(CL5DBFile *file);
-static int _cl5WriteEntryCount(CL5DBFile *file);
+static int _cl5GetEntryCount(cldb_Handle *cldb);
+static int _cl5WriteEntryCount(cldb_Handle *cldb);
 
 /* misc */
 static char *_cl5GetHelperEntryKey(int type, char *csnStr);
-static Object *_cl5GetReplica(const slapi_operation_parameters *op, const char *replGen);
-static int _cl5FileEndsWith(const char *filename, const char *ext);
 
 static PRLock *cl5_diskfull_lock = NULL;
 static int cl5_diskfull_flag = 0;
 
 static void cl5_set_diskfull(void);
-static void cl5_set_no_diskfull(void);
 
+static int _cl5WriteReplicaRUV(Replica *r, void *arg);
+static int _cl5DeleteRUV(Replica *r, void *arg);
 /***** Module APIs *****/
 
 /* Name:        cl5Init
@@ -395,15 +380,10 @@ cl5Cleanup()
                 CL5_DB_ERROR if db initialization fails.
  */
 int
-cl5Open(const char *dir, const CL5DBConfig *config)
+cl5Open(const CL5DBConfig *config)
 {
     int rc;
 
-    if (dir == NULL) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, "cl5Open: null directory\n");
-        return CL5_BAD_DATA;
-    }
-
     if (s_cl5Desc.dbState == CL5_STATE_NONE) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "cl5Open - Changelog is not initialized\n");
@@ -426,7 +406,7 @@ cl5Open(const char *dir, const CL5DBConfig *config)
         goto done;
     }
 
-    rc = _cl5Open(dir, config, CL5_OPEN_NORMAL);
+    rc = _cl5Open(config, CL5_OPEN_NORMAL);
     if (rc != CL5_SUCCESS) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "cl5Open - Failed to open changelog\n");
@@ -505,49 +485,6 @@ cl5Close()
     return rc;
 }
 
-/* Name:        cl5Delete
-   Description:    removes changelog; changelog must be in the closed state.
-   Parameters:  dir - changelog directory
-   Return:        CL5_SUCCESS if successful;
-                CL5_BAD_STATE if the changelog is not in closed state;
-                CL5_BAD_DATA if invalid directory supplied
-                CL5_SYSTEM_ERROR if NSPR call fails
- */
-int
-cl5Delete(const char *dir)
-{
-    int rc;
-
-    if (dir == NULL) {
-        slapi_log_err(SLAPI_LOG_PLUGIN, repl_plugin_name_cl, "cl5Delete - NULL directory\n");
-        return CL5_BAD_DATA;
-    }
-
-    if (s_cl5Desc.dbState == CL5_STATE_NONE) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "cl5Delete - Changelog is not initialized\n");
-        return CL5_BAD_STATE;
-    }
-
-    slapi_rwlock_wrlock(s_cl5Desc.stLock);
-
-    if (s_cl5Desc.dbState != CL5_STATE_CLOSED) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "cl5Delete - Invalid state - %d\n", s_cl5Desc.dbState);
-        slapi_rwlock_unlock(s_cl5Desc.stLock);
-        return CL5_BAD_STATE;
-    }
-
-    rc = _cl5Delete(dir, PR_TRUE /* remove changelog dir */);
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "cl5Delete - Failed to remove changelog\n");
-    }
-
-    slapi_rwlock_unlock(s_cl5Desc.stLock);
-    return rc;
-}
-
 /* Name:        cl5DeleteDBSync
    Description: The same as cl5DeleteDB except the function does not return
                 until the file is removed.
@@ -555,9 +492,10 @@ cl5Delete(const char *dir)
 int
 cl5DeleteDBSync(Object *replica)
 {
-    Object *obj;
     int rc;
-    CL5DBFile *file;
+    Replica *r;
+    cldb_Handle *cldb;
+    Slapi_Backend *be;
 
     if (replica == NULL) {
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
@@ -577,29 +515,11 @@ cl5DeleteDBSync(Object *replica)
     if (rc != CL5_SUCCESS)
         return rc;
 
-    rc = _cl5GetDBFile(replica, &obj);
-    if (rc == CL5_SUCCESS) {
-        char *filename = NULL;
-        file = (CL5DBFile *)object_get_data(obj);
-        PR_ASSERT(file);
-        /* file->name is freed in _cl5DBDeleteFile */
-        filename = slapi_ch_strdup(file->name);
-
-        _cl5DBDeleteFile(obj);
-
-        /* wait until the file is gone */
-        while (PR_Access(filename, PR_ACCESS_EXISTS) == PR_SUCCESS) {
-            DS_Sleep(PR_MillisecondsToInterval(100));
-        }
-        slapi_ch_free_string(&filename);
-    } else {
-        Replica *r = (Replica *)object_get_data(replica);
-        PR_ASSERT(r);
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "cl5DeleteDBSync - "
-                                                           "File for replica at (%s) not found\n",
-                      slapi_sdn_get_dn(replica_get_root(r)));
-    }
+    r = (Replica*)object_get_data (replica);
+    cldb = replica_get_file_info(r);
+    be = slapi_be_select(replica_get_root(r));
 
+    slapi_back_ctrl_info(be, BACK_INFO_DBENV_CLDB_REMOVE, (void **)&(cldb->db));
     _cl5RemoveThread();
     return rc;
 }
@@ -619,8 +539,7 @@ int
 cl5GetUpperBoundRUV(Replica *r, RUV **ruv)
 {
     int rc;
-    Object *r_obj, *file_obj;
-    CL5DBFile *file;
+    cldb_Handle *cldb = replica_get_file_info(r);
 
     if (r == NULL || ruv == NULL) {
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
@@ -640,25 +559,10 @@ cl5GetUpperBoundRUV(Replica *r, RUV **ruv)
     if (rc != CL5_SUCCESS)
         return rc;
 
-    /* create a temporary replica object because of the interface we have */
-    r_obj = object_new(r, NULL);
-
-    rc = _cl5GetDBFile(r_obj, &file_obj);
-    if (rc == CL5_SUCCESS) {
-        file = (CL5DBFile *)object_get_data(file_obj);
-        PR_ASSERT(file && file->maxRUV);
-
-        *ruv = ruv_dup(file->maxRUV);
-
-        object_release(file_obj);
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "cl5GetUpperBoundRUV - "
-                                                           "Could not find DB object for replica\n");
-    }
-
-    object_release(r_obj);
-
-    _cl5RemoveThread();
+     PR_ASSERT(cldb && cldb->maxRUV);
+    *ruv = ruv_dup(cldb->maxRUV);
+    
+    _cl5RemoveThread ();
     return rc;
 }
 
@@ -677,12 +581,10 @@ cl5GetUpperBoundRUV(Replica *r, RUV **ruv)
                 CL5_MEMORY_ERROR if memory allocation fials.
  */
 int
-cl5ExportLDIF(const char *ldifFile, Object **replicas)
+cl5ExportLDIF(const char *ldifFile, Replica *replica)
 {
-    int i;
     int rc;
     PRFileDesc *prFile = NULL;
-    Object *obj;
 
     if (ldifFile == NULL) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
@@ -713,28 +615,13 @@ cl5ExportLDIF(const char *ldifFile, Object **replicas)
     slapi_log_err(SLAPI_LOG_PLUGIN, repl_plugin_name_cl,
                   "cl5ExportLDIF: starting changelog export to (%s) ...\n", ldifFile);
 
-    if (replicas) /* export only selected files */
-    {
-        for (i = 0; replicas[i]; i++) {
-            rc = _cl5GetDBFile(replicas[i], &obj);
-            if (rc == CL5_SUCCESS) {
-                rc = _cl5ExportFile(prFile, obj);
-                object_release(obj);
-            } else {
-                Replica *r = (Replica *)object_get_data(replicas[i]);
-
-                PR_ASSERT(r);
-
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, "cl5ExportLDIF - "
-                                                                  "Failed to locate changelog file for replica at (%s)\n",
-                              slapi_sdn_get_dn(replica_get_root(r)));
-            }
-        }
-    } else /* export all files */
-    {
-        for (obj = objset_first_obj(s_cl5Desc.dbFiles); obj;
-             obj = objset_next_obj(s_cl5Desc.dbFiles, obj)) {
-            rc = _cl5ExportFile(prFile, obj);
+    if (replica) {/* export only selected files */
+        cldb_Handle *cldb = replica_get_file_info(replica);
+        rc = _cl5ExportFile (prFile, cldb);
+        if (rc) {
+            slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, "cl5ExportLDIF - "
+                          "failed to locate changelog file for replica at (%s)\n",
+                          slapi_sdn_get_dn (replica_get_root (replica)));
         }
     }
 
@@ -766,7 +653,7 @@ done:;
                 CL5_MEMORY_ERROR if memory allocation fials.
  */
 int
-cl5ImportLDIF(const char *clDir, const char *ldifFile, Object **replicas)
+cl5ImportLDIF(const char *clDir, const char *ldifFile, Replica *replica)
 {
 #if defined(USE_OPENLDAP)
     LDIFFP *file = NULL;
@@ -779,12 +666,7 @@ cl5ImportLDIF(const char *clDir, const char *ldifFile, Object **replicas)
     int rc;
     char *buff = NULL;
     slapi_operation_parameters op;
-    Object *prim_replica_obj = NULL;
-    Object *replica_obj = NULL;
-    Object *file_obj = NULL;
-    Replica *prim_replica = NULL;
     char *replGen = NULL;
-    CL5DBFile *dbfile = NULL;
     struct berval **purgevals = NULL;
     struct berval **maxvals = NULL;
     int purgeidx = 0;
@@ -806,21 +688,12 @@ cl5ImportLDIF(const char *clDir, const char *ldifFile, Object **replicas)
         return CL5_BAD_STATE;
     }
 
-    if (replicas == NULL) {
+    if (replica == NULL) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "cl5ImportLDIF - null list of replicas\n");
         return CL5_BAD_DATA;
     }
 
-    prim_replica_obj = replicas[0];
-    if (NULL == prim_replica_obj) {
-        /* Never happens for now. (see replica_execute_ldif2cl_task) */
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "cl5ImportLDIF - empty replica list\n");
-        return CL5_BAD_DATA;
-    }
-    prim_replica = (Replica *)object_get_data(prim_replica_obj);
-
     /* make sure that nobody change changelog state while import is in progress */
     slapi_rwlock_wrlock(s_cl5Desc.stLock);
 
@@ -848,21 +721,23 @@ cl5ImportLDIF(const char *clDir, const char *ldifFile, Object **replicas)
     }
 
     /* remove changelog */
-    rc = _cl5Delete(clDir, PR_FALSE);
+    /* TBD remove and recreate cl database */
+    /* rc = _cl5Delete(clDir, PR_FALSE);
     if (rc != CL5_SUCCESS) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "cl5ImportLDIF - Failed to remove changelog\n");
         goto done;
-    }
+    }*/
 
     /* open changelog */
-    rc = _cl5Open(clDir, NULL, CL5_OPEN_LDIF2CL);
+    rc = _cl5Open(NULL, CL5_OPEN_LDIF2CL);
     if (rc != CL5_SUCCESS) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "cl5ImportLDIF - Failed to open changelog\n");
         goto done;
     }
     s_cl5Desc.dbState = CL5_STATE_OPEN; /* force to change the state */
+    cldb_Handle *cldb = replica_get_file_info(replica);
 
 /* read entries and write them to changelog */
 #if defined(USE_OPENLDAP)
@@ -934,18 +809,16 @@ cl5ImportLDIF(const char *clDir, const char *ldifFile, Object **replicas)
 #if defined(USE_OPENLDAP)
         buflen = 0;
 #endif
-        /* if we perform selective import, check if the operation should be wriiten to changelog */
-        replica_obj = _cl5GetReplica(&op, replGen);
-        if (replica_obj == NULL) {
-            /*
+        /* check if the operation should be written to changelog */
+	if (0 == strcmp(replGen, cldb->ident)) {
+            /* 
              * changetype: delete
              * replgen: 4d13a124000000010000
              * csn: 4d23b909000000020000
              * nsuniqueid: 00000000-00000000-00000000-00000000
              * dn: cn=start iteration
              */
-            rc = _cl5WriteOperation(replica_get_name(prim_replica),
-                                    replGen, &op, 1);
+            rc = _cl5WriteOperation (cldb, &op, 1);
             if (rc != CL5_SUCCESS) {
                 slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                               "cl5ImportLDIF - "
@@ -960,56 +833,22 @@ cl5ImportLDIF(const char *clDir, const char *ldifFile, Object **replicas)
             goto next;
         }
 
-        if (!replicas || _cl5ReplicaInList(replica_obj, replicas)) {
-            /* write operation creates the file if it does not exist */
-            rc = _cl5WriteOperation(replica_get_name((Replica *)object_get_data(replica_obj)),
-                                    replGen, &op, 1);
-            if (rc != CL5_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "cl5ImportLDIF - "
-                              "Failed to write operation to the changelog: "
-                              "type: %lu, dn: %s\n",
-                              op.operation_type, REPL_GET_DN(&op.target_address));
-                object_release(replica_obj);
-                slapi_ch_free_string(&replGen);
-                operation_parameters_done(&op);
-                goto done;
-            }
-            entryCount++;
-        }
-    next:
-        if (replica_obj) {
-            object_release(replica_obj);
-        }
+next:
         slapi_ch_free_string(&replGen);
         operation_parameters_done(&op);
     }
 
-    /* Set RUVs and entry count */
-    file_obj = objset_first_obj(s_cl5Desc.dbFiles);
-    while (file_obj) {
-        dbfile = (CL5DBFile *)object_get_data(file_obj);
-        if (0 == strcasecmp(dbfile->replName, replica_get_name(prim_replica))) {
-            break;
-        }
-        dbfile = NULL;
-        file_obj = objset_next_obj(s_cl5Desc.dbFiles, file_obj);
-    }
-
-    if (dbfile) {
+    if (cldb) {
         if (purgeidx > 0) {
-            ruv_destroy(&dbfile->purgeRUV);
-            rc = ruv_init_from_bervals(purgevals, &dbfile->purgeRUV);
+            ruv_destroy(&cldb->purgeRUV);
+            rc = ruv_init_from_bervals(purgevals, &cldb->purgeRUV);
         }
         if (maxidx > 0) {
-            ruv_destroy(&dbfile->maxRUV);
-            rc = ruv_init_from_bervals(maxvals, &dbfile->maxRUV);
+            ruv_destroy(&cldb->maxRUV);
+            rc = ruv_init_from_bervals(maxvals, &cldb->maxRUV);
         }
 
-        dbfile->entryCount = entryCount;
-    }
-    if (file_obj) {
-        object_release(file_obj);
+        cldb->entryCount = entryCount;
     }
 
 done:
@@ -1126,6 +965,8 @@ cl5GetOperation(Object *replica, slapi_operation_parameters *op)
 {
     int rc;
     char *agmt_name;
+    Replica *r;
+    cldb_Handle *cldb;
 
     agmt_name = get_thread_private_agmtname();
 
@@ -1155,7 +996,9 @@ cl5GetOperation(Object *replica, slapi_operation_parameters *op)
     if (rc != CL5_SUCCESS)
         return rc;
 
-    rc = _cl5GetOperation(replica, op);
+    r = (Replica *)object_get_data(replica);
+    cldb = replica_get_file_info(r);
+    rc = _cl5GetOperation (cldb, op);
 
     _cl5RemoveThread();
 
@@ -1177,8 +1020,8 @@ cl5GetFirstOperation(Object *replica, slapi_operation_parameters *op, void **ite
 {
     int rc;
     CL5Entry entry;
-    Object *obj;
-    char *agmt_name;
+    Replica *r = (Replica*)object_get_data (replica);
+    cldb_Handle *cldb;
 
     if (replica == NULL || op == NULL || iterator == NULL) {
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
@@ -1189,7 +1032,7 @@ cl5GetFirstOperation(Object *replica, slapi_operation_parameters *op, void **ite
     *iterator = NULL;
 
     if (s_cl5Desc.dbState == CL5_STATE_NONE) {
-        agmt_name = get_thread_private_agmtname();
+        char *agmt_name = get_thread_private_agmtname();
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
                       "cl5GetFirstOperation - %s - Changelog is not initialized\n", agmt_name);
         return CL5_BAD_STATE;
@@ -1200,7 +1043,7 @@ cl5GetFirstOperation(Object *replica, slapi_operation_parameters *op, void **ite
     if (rc != CL5_SUCCESS)
         return rc;
 
-    rc = _cl5GetDBFile(replica, &obj);
+    cldb = replica_get_file_info (r);
     if (rc != CL5_SUCCESS) {
         _cl5RemoveThread();
         return rc;
@@ -1208,8 +1051,7 @@ cl5GetFirstOperation(Object *replica, slapi_operation_parameters *op, void **ite
 
     entry.op = op;
     /* Callers of this function should cl5_operation_parameters_done(op) */
-    rc = _cl5GetFirstEntry(obj, &entry, iterator, NULL);
-    object_release(obj);
+    rc = _cl5GetFirstEntry(cldb, &entry, iterator, NULL);
 
     _cl5RemoveThread();
 
@@ -1268,10 +1110,11 @@ cl5DestroyIterator(void *iterator)
     if (it->cursor)
         it->cursor->c_close(it->cursor);
 
-    if (it->file)
-        object_release(it->file);
-
-    slapi_ch_free((void **)&it);
+    /* TBD locking of CL files */
+    /* if (it->file)
+	object_release (it->file);
+     */
+    slapi_ch_free ((void**)&it);
 }
 
 /* Name:        cl5WriteOperationTxn
@@ -1291,7 +1134,7 @@ cl5DestroyIterator(void *iterator)
                 CL5_DB_ERROR if any other db error occured;
  */
 int
-cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_operation_parameters *op, PRBool local, void *txn)
+cl5WriteOperationTxn(cldb_Handle *cldb, const slapi_operation_parameters *op, PRBool local, void *txn)
 {
     int rc;
 
@@ -1317,16 +1160,11 @@ cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_oper
     if (rc != CL5_SUCCESS)
         return rc;
 
-    rc = _cl5WriteOperationTxn(replName, replGen, op, local, txn);
+    rc = _cl5WriteOperationTxn(cldb, op, local, txn);
 
     /* update the upper bound ruv vector */
     if (rc == CL5_SUCCESS) {
-        Object *file_obj = NULL;
-
-        if (_cl5GetDBFileByReplicaName(replName, replGen, &file_obj) == CL5_SUCCESS) {
-            rc = _cl5UpdateRUV(file_obj, op->csn, PR_FALSE, PR_FALSE);
-            object_release(file_obj);
-        }
+        rc = _cl5UpdateRUV(cldb, op->csn, PR_FALSE, PR_FALSE);
     }
 
     _cl5RemoveThread();
@@ -1350,9 +1188,9 @@ cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_oper
                 CL5_DB_ERROR if any other db error occured;
  */
 int
-cl5WriteOperation(const char *replName, const char *replGen, const slapi_operation_parameters *op, PRBool local)
+cl5WriteOperation(cldb_Handle *cldb, const slapi_operation_parameters *op, PRBool local)
 {
-    return cl5WriteOperationTxn(replName, replGen, op, local, NULL);
+    return cl5WriteOperationTxn(cldb, op, local, NULL);
 }
 
 /* Name:        cl5CreateReplayIterator
@@ -1393,7 +1231,6 @@ cl5CreateReplayIteratorEx(Private_Repl_Protocol *prp, const RUV *consumerRuv, CL
 {
     int rc;
     Object *replica;
-    Object *obj = NULL;
 
     replica = prp->replica_object;
     if (replica == NULL || consumerRuv == NULL || iterator == NULL) {
@@ -1411,31 +1248,19 @@ cl5CreateReplayIteratorEx(Private_Repl_Protocol *prp, const RUV *consumerRuv, CL
     }
 
     /* make sure that changelog is open while operation is in progress */
-    rc = _cl5AddThread();
-    if (rc != CL5_SUCCESS)
-        return rc;
-
+    rc = _cl5AddThread ();
+    if (rc != CL5_SUCCESS ) return rc;
 
-    rc = _cl5GetDBFile(replica, &obj);
-    if (rc == CL5_SUCCESS && obj) {
-        /* iterate through the ruv in csn order to find first master for which
-           we can replay changes */
-
-        rc = _cl5PositionCursorForReplay(consumerRID, consumerRuv, replica, obj, iterator, NULL);
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "cl5CreateReplayIteratorEx - Could not find DB object for replica\n");
-    }
+    /* iterate through the ruv in csn order to find first master for which 
+       we can replay changes */		    
+    rc = _cl5PositionCursorForReplay (consumerRID, consumerRuv, replica, iterator, NULL);
 
     if (rc != CL5_SUCCESS) {
-        if (obj)
-            object_release(obj);
-
         /* release the thread */
-        _cl5RemoveThread();
+        _cl5RemoveThread ();
     }
 
-    return rc;
+return rc;	
 }
 
 /* cl5CreateReplayIterator is now a wrapper for cl5CreateReplayIteratorEx */
@@ -1450,7 +1275,6 @@ cl5CreateReplayIterator(Private_Repl_Protocol *prp, const RUV *consumerRuv, CL5R
 
     int rc;
     Object *replica;
-    Object *obj = NULL;
 
     replica = prp->replica_object;
     if (replica == NULL || consumerRuv == NULL || iterator == NULL) {
@@ -1473,27 +1297,18 @@ cl5CreateReplayIterator(Private_Repl_Protocol *prp, const RUV *consumerRuv, CL5R
         return rc;
 
 
-    rc = _cl5GetDBFile(replica, &obj);
-    if (rc == CL5_SUCCESS && obj) {
-        /* iterate through the ruv in csn order to find first master for which
-           we can replay changes */
-        ReplicaId consumerRID = agmt_get_consumer_rid(prp->agmt, prp->conn);
-        int continue_on_missing = agmt_get_ignoremissing(prp->agmt);
-        int save_cont_miss = continue_on_missing;
-        rc = _cl5PositionCursorForReplay(consumerRID, consumerRuv, replica, obj, iterator, &continue_on_missing);
-        if (save_cont_miss == 1 && continue_on_missing == 0) {
-            /* the option to continue once on a missing csn was used, rest */
-            agmt_set_ignoremissing(prp->agmt, 0);
-        }
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "cl5CreateReplayIterator - Could not find DB object for replica\n");
+    /* iterate through the ruv in csn order to find first master for which
+       we can replay changes */
+    ReplicaId consumerRID = agmt_get_consumer_rid(prp->agmt, prp->conn);
+    int continue_on_missing = agmt_get_ignoremissing(prp->agmt);
+    int save_cont_miss = continue_on_missing;
+    rc = _cl5PositionCursorForReplay(consumerRID, consumerRuv, replica, iterator, &continue_on_missing);
+    if (save_cont_miss == 1 && continue_on_missing == 0) {
+        /* the option to continue once on a missing csn was used, rest */
+        agmt_set_ignoremissing(prp->agmt, 0);
     }
 
     if (rc != CL5_SUCCESS) {
-        if (obj)
-            object_release(obj);
-
         /* release the thread */
         _cl5RemoveThread();
     }
